<div class="kikfyre kf-container"  ng-controller="eventCtrl" ng-app="eventMagicApp" ng-cloak ng-init="initialize('event_settings')">
    <div class="kf_progress_screen" ng-show="requestInProgress"></div>
    <div class="kf-db-content">
        <div class="kf-db-title">
             <?php _e('Event Settings','eventprime-event-calendar-management'); ?>
        </div>
        <div class="form_errors">
            <ul>
                <li class="emfield_error" ng-repeat="error in  formErrors">
                    <span>{{error}}</span>
                </li>
            </ul>  
        </div>
        <!-- FORM -->
        <form  name="postForm" ng-submit="savePost(postForm.$valid)" novalidate>

            <div class="emrow">
                <div class="emfield"><?php _e('Name','eventprime-event-calendar-management'); ?><sup>*</sup></div>
                <div class="eminput">
                    <input required type="text" name="name"  ng-model="data.post.name">
                    <div class="emfield_error">
                        <span ng-show="postForm.name.$error.required && (showFormErrors || !postForm.name.$pristine)"><?php _e('This is a required field.','eventprime-event-calendar-management'); ?></span>
                    </div>
                </div>
                <div class="emnote"><i class="fa fa-info-circle" aria-hidden="true"></i>
                    <?php _e('Name of your Event. Should be unique.','eventprime-event-calendar-management'); ?>
                </div>
            </div>

            <div class="emrow">
                <div class="emfield"><?php _e('Event Type','eventprime-event-calendar-management'); ?><sup>*</sup></div>
                <div class="eminput">
                    <select required name="event_type"  ng-model="data.post.event_type" ng-options="event_type.id as event_type.name for event_type in data.post.event_types"></select>
                    <div class="emfield_error">
                        <span ng-show="(postForm.event_type.$error.required && !postForm.event_type.$pristine) || (data.post.event_type == 0 && postForm.event_type.$setValidity('required', false))"><?php _e('This is a required field.','eventprime-event-calendar-management'); ?></span>
                    </div>

                </div>
                <div class="emnote"><i class="fa fa-info-circle" aria-hidden="true"></i>
                    <?php _e('Event category. Example: Musical Fest, Seminar, Sports etc.','eventprime-event-calendar-management'); ?>
                </div>
            </div>
            
            <!-- New Event Type Fields -->
            <div ng-show="data.post.event_type == 'new_event_type'">
                <div class="emrow">
                    <div class="emfield"><?php _e('New Event Type Name','eventprime-event-calendar-management'); ?><sup>*</sup></div>
                    <div class="eminput">
                        <input type="text" name="new_event_type" ng-required="data.post.event_type=='new_event_type'" ng-model="data.post.new_event_type" />
                   
                    <div class="emfield_error">
                        <span ng-show="postForm.new_event_type.$error.required && !postForm.new_event_type.$pristine"><?php _e('This is a required field.','eventprime-event-calendar-management'); ?></span>
                    </div>
                    </div>

                    <div class="emnote"><i class="fa fa-info-circle" aria-hidden="true"></i>
                        <?php _e('Name of your Event Category.Should be unique.','eventprime-event-calendar-management'); ?>
                    </div>
                </div>

                <div class="emrow">
                    <div class="emfield"><?php _e('New Event Type Color','eventprime-event-calendar-management'); ?><sup>*</sup></div>
                    <div class="eminput">
                        <input class="jscolor" type="text" name="new_event_type_color" ng-model="data.post.new_event_type_color" /></select>
                    </div>
                    <div class="emfield_error">
                        <span>&nbsp;</span>
                    </div>
                    <div class="emnote">
                        <i class="fa fa-info-circle" aria-hidden="true"></i>
                        <?php _e('Color of your Event Type for better identification by users','eventprime-event-calendar-management'); ?>
                    </div>
                </div>
            </div>
            <!-- New Event Type Ends here -->
            
            <div class="emrow kf-bg-light">
                <div class="emfield emeditor"><?php _e('Description','eventprime-event-calendar-management'); ?></div>
                <div class="eminput emeditor">
                    <?php
                    $post_id = event_m_get_param('post_id');
                    $content = '';
                    if ($post_id !== null && (int) $post_id > 0) {
                        $post = get_post($post_id);
                        if (!empty($post))
                            $content = $post->post_content;
                    }
                    em_add_editor('description', $content);
                    ?>
                    <div class="emfield_error">
                    </div>
                </div>
                <div class="emnote emeditor">
                    <?php _e('Details about the Event that will be visible to the users on events page.','eventprime-event-calendar-management'); ?>
                </div>
            </div>

            <div class="emrow">
                <div class="emfield"><?php _e('Feature Image','eventprime-event-calendar-management'); ?></div>
                <div class="eminput">
                    <input type="button" ng-click="mediaUploader(false)" class="button kf-upload" value="<?php _e('Upload','eventprime-event-calendar-management'); ?>" />
                    <div class="em_cover_image">
                        <img ng-src="{{data.post.cover_image_url}}" />
                    </div>
                </div>

                <div class="emnote"><i class="fa fa-info-circle" aria-hidden="true"></i>
                    <?php _e('Large image for the Event. This will be displayed above Description prominently.','eventprime-event-calendar-management'); ?>
                </div>
            </div>

            <div class="emrow kf-bg-light">
                <div class="emfield emeditor"><?php _e('Event Gallery','eventprime-event-calendar-management'); ?></div>
                <div class="eminput emeditor">
                    <input  type="button" ng-click="mediaUploader(true)" class="button kf-upload" value="<?php _e('Upload','eventprime-event-calendar-management'); ?>" />
                    <div class="em_gallery_images">
                        <ul id="em_draggable" class="dbfl">
                            <li class="kf-db-image difl" ng-repeat="(key, value) in data.post.images" id="{{value.id}}">
                                <div><img ng-src="{{value.src[0]}}" />
                                    <span><input class="em-remove_button" type="button" ng-click="deleteGalleryImage(value.id, key, data.post.images, data.post.gallery_image_ids)" value="<?php _e('Remove','eventprime-event-calendar-management'); ?>" /></span> 
                                </div>
                            </li>
                        </ul>
                    </div>
                </div>

                <div class="emnote emeditor">
                    <?php _e('Displays multiple images related to the event as gallery view on Event page.','eventprime-event-calendar-management'); ?>
                </div>
            </div>

            <div class="emrow">
                <div class="emfield"><?php _e('Day Starts','eventprime-event-calendar-management'); ?><sup>*</sup></div>
                <div class="eminput">
                    <input required id="event_start_date" readonly=""  type="text" name="start_date"  ng-model="data.post.start_date">
                    <div class="emfield_error">
                        <span ng-show="postForm.start_date.$error.required && !postForm.start_date.$pristine"><?php _e('This is a required field.','eventprime-event-calendar-management'); ?></span>
                        <span ng-show="postForm.start_date.$error.pattern && !postForm.start_date.$pristine"><?php _e('Format should be DD/MM/YYYY','eventprime-event-calendar-management'); ?></span>
                    </div>
                </div>
                <div class="emnote"><i class="fa fa-info-circle" aria-hidden="true"></i>
                    <?php _e('Event start date and time.','eventprime-event-calendar-management'); ?>
                </div>
            </div>

            <div class="emrow">
                <div class="emfield"><?php _e('Day Ends','eventprime-event-calendar-management'); ?><sup>*</sup></div>
                <div class="eminput">
                    <input required id="event_end_date" readonly="readonly" type="text" name="end_date"  ng-model="data.post.end_date" ng-change="update_start_booking_date()">
                    <div class="emfield_error">
                        <span ng-show="postForm.end_date.$error.required && !postForm.end_date.$pristine"><?php _e('This is a required field.','eventprime-event-calendar-management'); ?></span>
                        <span ng-show="postForm.end_date.$error.pattern && !postForm.end_date.$pristine"><?php _e('Format should be DD/MM/YYYY','eventprime-event-calendar-management'); ?></span>
                    </div>
                </div>
                <div class="emnote"><i class="fa fa-info-circle" aria-hidden="true"></i>
                    <?php _e('Event end date and time. Should always be later than the Start Date.','eventprime-event-calendar-management'); ?>
                </div>
            </div>
            
            <div class="emrow">
                <div class="emfield"><?php _e('Enable Bookings','eventprime-event-calendar-management'); ?></div>
                <div class="eminput">
                    <input type="checkbox" name="enable_booking"  ng-model="data.post.enable_booking"  ng-true-value="1" ng-false-value="0">
                </div>
            </div>
            
            <div ng-show="data.post.enable_booking">
                <div class="emrow">
                    <div class="emfield"><?php _e('Start Booking Date','eventprime-event-calendar-management'); ?></div>
                    <div class="eminput">
                        <input id="event_start_booking_date" readonly="readonly" type="text" name="start_booking_date"  ng-model="data.post.start_booking_date">
                        <div class="emfield_error">
                            <span ng-show="postForm.start_booking_date.$error.pattern && !postForm.start_booking_date.$pristine"><?php _e('Format should be DD/MM/YYYY','eventprime-event-calendar-management'); ?></span>
                        </div>
                    </div>
                    <div class="emnote"><i class="fa fa-info-circle" aria-hidden="true"></i>
                        <?php _e('The date from which booking opens.','eventprime-event-calendar-management'); ?>
                    </div>
                </div>

                <div class="emrow">
                    <div class="emfield"><?php _e('Last Booking Date','eventprime-event-calendar-management'); ?></div>
                    <div class="eminput">
                        <input id="event_last_booking_date" readonly="readonly" type="text" name="last_booking_date"  ng-model="data.post.last_booking_date">
                        <div class="emfield_error">
                            <span ng-show="postForm.last_booking_date.$error.pattern && !postForm.last_booking_date.$pristine"><?php _e('Format should be DD/MM/YYYY','eventprime-event-calendar-management'); ?></span>
                        </div>
                    </div>
                    <div class="emnote"><i class="fa fa-info-circle" aria-hidden="true"></i>
                        <?php _e('The date on which booking closes.','eventprime-event-calendar-management'); ?>
                    </div>
                </div>
                
                <div class="emrow">
                    <div class="emfield"><?php _e('Booking Price', 'eventprime-event-seating'); ?></div>
                    <div class="eminput em_price_input"><span class="em_price_symbol">{{data.post.currency}}</span>
                        <input type="number" ng-min="0" name="ticket_price" ng-min="1"  ng-model="data.post.ticket_price" >
                        <div class="emfield_error">
                            <span ng-show="postForm.ticket_price.$error.number && !postForm.ticket_price.$pristine"><?php _e('Only numeric value allowed.', 'eventprime-event-seating'); ?></span>
                            <span ng-show="postForm.ticket_price.$error.min && !postForm.ticket_price.$pristine"><?php _e('Invalid value.', 'eventprime-event-seating'); ?></span>
                            <span ng-show="postForm.ticket_price.$error.required && !postForm.ticket_price.$pristine"><?php _e('This is a required field.', 'eventprime-event-seating'); ?></span>
                        </div>
                    </div>
                    <div class="emnote"><i class="fa fa-info-circle" aria-hidden="true"></i>
                        <?php _e('Single booking price. Currency can be changed through Global Settings.', 'eventprime-event-seating'); ?>
                    </div>
                </div>

                <div class="emrow">
                    <div class="emfield"><?php _e('Hide Booking Status','eventprime-event-calendar-management'); ?></div>
                    <div class="eminput">
                        <input type="checkbox" name="hide_booking_status"  ng-model="data.post.hide_booking_status"  ng-true-value="1" ng-false-value="0">
                    </div>
                    <div class="emnote"><i class="fa fa-info-circle" aria-hidden="true"></i>
                        <?php _e('Hides booking status from the viewers on Event page.','eventprime-event-calendar-management'); ?>
                    </div>
                </div>

                <div class="emrow">
                    <div class="emfield"> <?php _e('Allow Cancellations','eventprime-event-calendar-management'); ?></div>
                    <div class="eminput">
                        <input type="checkbox" name="allow_cancellations"  ng-model="data.post.allow_cancellations" ng-true-value="1" ng-false-value="0">
                    </div>
                    <div class="emnote"><i class="fa fa-info-circle" aria-hidden="true"></i>
                        <?php _e('Allow users to request for booking cancellation from User Profile page. Seats will be revoked and freed up for selection just after cancellation request.','eventprime-event-calendar-management'); ?>
                    </div>
                </div>
            </div>
            
            <?php $show_rm= is_registration_magic_active(); ?>
            <div class="emrow" ng-show="data.rm_forms && <?php echo absint($show_rm); ?>">
                <div class="emfield"><?php _e('Event Registration Form','eventprime-event-calendar-management'); ?></div>
                <div class="eminput">
                    <select name="rm_form" ng-model="data.post.rm_form" ng-options="key as value for (key, value) in data.rm_forms" convert-to-number></select>
                    <div class="emfield_error">
                    </div>
                </div>
                <div class="emnote"><i class="fa fa-info-circle" aria-hidden="true"></i>
                    <?php printf(__("Select a <a target='_blank' href='%s'>RegistrationMagic</a> form as this event's user registration form. Leave the option at ''Default EventPrime Form' if you do not wish to use a <a target='_blank' href='%s'>RegistrationMagic</a> form. On choosing 'Default EventPrime Form',  EventPrime will auto-generate a user registration form for this event.",'eventprime-event-calendar-management'),admin_url('admin.php?page=rm_form_manage'),admin_url('admin.php?page=rm_form_manage')); ?>
                </div>
            </div>
            
            <div class="emrow">
                <div class="emfield"><?php _e('All Day','eventprime-event-calendar-management'); ?></div>
                <div class="eminput">
                    <input  type="checkbox" name="all_day" ng-change="allDay()"  ng-model="data.post.all_day" ng-true-value="1" ng-false-value="0">
                </div>
                <div class="emnote"><i class="fa fa-info-circle" aria-hidden="true"></i>
                    <?php _e('Enable this option if your event has no specific start & end time.','eventprime-event-calendar-management'); ?>
                </div>
            </div>
            
            <div class="emrow">
                <div class="emfield"><?php _e('Hide on Events Calendar Widget','eventprime-event-calendar-management'); ?></div>
                <div class="eminput">
                    <input  type="checkbox" name="hide_event_from_calendar"  ng-model="data.post.hide_event_from_calendar" ng-true-value="1" ng-false-value="0">
                </div>
                <div class="emnote"><i class="fa fa-info-circle" aria-hidden="true"></i>
                    <?php _e('Hides Event from calendar widget.','eventprime-event-calendar-management'); ?>
                </div>
            </div>

            <div class="emrow">
                <div class="emfield"><?php _e('Hide from Events Directory','eventprime-event-calendar-management'); ?></div>
                <div class="eminput">
                    <input  type="checkbox" name="hide_event_from_events"  ng-model="data.post.hide_event_from_events" ng-true-value="1" ng-false-value="0">
                </div>
                <div class="emnote"><i class="fa fa-info-circle" aria-hidden="true"></i>
                    <?php _e("Hides Event from Event's directory.",'eventprime-event-calendar-management'); ?>
                </div>
            </div>

            <div class="emrow kf-bg-light">
                <div class="emfield"><?php _e('Note for Attendees','eventprime-event-calendar-management'); ?></div>
                <div class="eminput emeditor">
                    <textarea class="kf-note" name="audience_notice"  ng-model="data.post.audience_notice"></textarea>
                    <div class="emfield_error">
                    </div>
                </div>
                <div class="emnote emeditor">
                    <?php _e('Notice for audience on Event page. Can be used for important instructions related to the event.','eventprime-event-calendar-management'); ?>
                </div>
            </div>

            <div class="emrow">
                <div class="emfield"><?php _e('Status','eventprime-event-calendar-management'); ?></div>
                <div class="eminput">
                    <select required name="status"  ng-model="data.post.status" ng-options="status.key as status.label for status in data.post.status_list"></select>
                    <div class="emfield_error">
                        <span ng-show="postForm.status.$error.required && !postForm.status.$pristine"><?php _e('This is a required field.','eventprime-event-calendar-management'); ?></span>
                    </div>
                </div>
                <div class="emnote">
                    <?php _e('Event status (Expired or Active). Booking is not allowed for expired Events. System automatically changes status to Expired based on Event dates.','eventprime-event-calendar-management'); ?>
                </div>
            </div>

            <input type="text" class="hidden"  ng-model="data.post.cover_image_id" />
            <input type="text" class="hidden" ng-model="data.post.gallery_image_ids" />

            <div class="dbfl kf-buttonarea">
                <div class="em_cancel"><a class="kf-cancel" href="<?php echo admin_url('/admin.php?page=em_dashboard&post_id=' . $post_id); ?>"><?php _e('Cancel','eventprime-event-calendar-management'); ?></a></div>
                <button type="submit" class="btn btn-primary" ng-disabled="postForm.$invalid || requestInProgress"><?php _e('Save','eventprime-event-calendar-management'); ?></button>

            </div>


            <div class="dbfl kf-required-errors" ng-show="postForm.$dirty && postForm.$invalid">
                <h3><?php _e("Looks like you missed out filling some required fields (*). You will not be able to save until all required fields are filled in. Here’s what's missing",'eventprime-event-calendar-management') ?> -

                    <span ng-show="postForm.name.$error.required"><?php _e('Name','eventprime-event-calendar-management'); ?></span>

                    <span ng-show="postForm.start_date.$error.required"><?php _e('Day Starts','eventprime-event-calendar-management'); ?></span>

                    <span ng-show="postForm.end_date.$error.required"><?php _e('Day Ends','eventprime-event-calendar-management'); ?></span>

                    <span ng-show="postForm.new_event_type.$error.required || postForm.event_type.$error.required"><?php _e('Event Type','eventprime-event-calendar-management'); ?></span>

                </h3>

            </div>

        </form>
    </div>
</div>
