
/************************************* Event Controller ***********************************/

eventMagicApp.controller('eventCtrl', function ($scope, $http, MediaUploader, Seat,TermUtility,EMRequest,PostUtility,$location) {
    // Model for Event data
    $scope.data = {};
    $scope.screen='';
    $scope.data.manager_nav= "event";
    $scope.requestInProgress= false;
    $scope.selectedSeats = [];
    $scope.post_id = 0;
    $scope.paged=1;
    $scope.selections= [];
    $scope.post_edit= false;
    $scope.seat_container_width='';
    $scope.progressBarStyle='';
    $scope.scheme_popup =  false;
    $scope.seatPopup= false;
    $scope.IsVisible = false;
    $scope.data.full_load= true;
    $scope.mapConfigured=false;
    $= jQuery;
    
    angular.element(document).ready(function () {
        em_set_date_defaults();
    });
    /*
     * Controller intitialization for data load 
     */
    $scope.initialize = function (screen) {
        if (screen == "list") {
            $scope.prepareEventListPage();
            $scope.screen='list';
        }
        else
        {
            $scope.screen=screen;
            $scope.preparePageData();
            // Adding Jquery Sortable function for Gallery
            jQuery("#em_draggable").sortable({
                stop: function (event, ui) {
                    $scope.data.post.gallery_image_ids = jQuery("#em_draggable").sortable('toArray');
                    $scope.$apply();
                }
            });
        }
    }
    
    angular.element(document).ready(function () {
        em_set_date_defaults();
    });
    
    /* Show/Hide element while performing HTTP request */
    $scope.progressStart= function()
    {
        $scope.requestInProgress = true;
    }
    
    $scope.progressStop= function()
    {
        $scope.requestInProgress = false;
    }
    
    /********************** Add/Edit event functions*******************************/
    /*
    * 
    * Loading seat container width as per initial seating structure
    */ 
    $scope.setSeatContainerWidth= function()
    {
        if ($scope.data.post.seats!== undefined && $scope.data.post.seats.length>0) {

                 var seat_container_width= ($scope.data.post.seats[0].length*35) + 80 + "px";
                 $scope.seat_container_width={ "width" : seat_container_width };

         }
    }
   
    /*
     * 
     * WordPress default media uploader to choose image
     */
    $scope.mediaUploader = function (multiImage) {
        var mediaUploader = MediaUploader.openUploader(multiImage);
        mediaUploader.on('select', function () {
            attachments = mediaUploader.state().get('selection');
            attachments.map(function (attachment) {
                attachment = attachment.toJSON();
                if (multiImage) {
                    // For gallery images
                   // var imageObj = {src: [attachment.sizes.thumbnail.url], id: attachment.id};
                  var imageObj = attachment.sizes.thumbnail===undefined ? {src: [attachment.sizes.full.url], id: attachment.id} : {src: [attachment.sizes.thumbnail.url], id: attachment.id};
                    $scope.data.post.images.push(imageObj);

                    $scope.data.post.gallery_image_ids.push(attachment.id);

                } else {
                    // For cover image
                    $scope.data.post.cover_image_id = attachment.id;
                   $scope.data.post.cover_image_url = attachment.sizes.thumbnail===undefined ? attachment.sizes.full.url : attachment.sizes.thumbnail.url;
                }

                $scope.$apply();
            });
        });
        // Open the uploader dialog
        mediaUploader.open();
    }

    /*
     * Empty gallery images
     */  
    $scope.deleteGalleryImage = function (image_id, index, image_model, ids) { 
        image_model.splice(index, 1);
        ids = em_remove_from_array(ids, image_id);
    }
    
    $scope.$watch('data.post.allow_discount', function (newVal, oldVal) {
        if (parseInt(newVal) == 1)
            jQuery("#em_volume_discount").show("slow");
        else
            jQuery("#em_volume_discount").hide("slow");
    });

    /*
     * Verifying event capacity with venue capcity 
     */
    $scope.verify_capacity= function(newVal)
    {
        var data= {};
        data.venue_id= $scope.data.post.venue;
        data.event_id= $scope.data.post.id;
         
        $scope.progressStart();
        EMRequest.send('em_get_venue_capcity',data).then(function(response){
        //    alert(response.data.capacity);  
                $scope.data.venue_capacity= response.data.capacity;
                if($scope.data.venue_capacity>0 && newVal>$scope.data.venue_capacity)
                    $scope.postForm.seating_capacity.$setValidity("capacityExceeded", false);
                else
                    $scope.postForm.seating_capacity.$setValidity("capacityExceeded", true);
                $scope.progressStop();
            });
    }
    
    /*
     * 
     * Adding new performer
     */
    $scope.addPerformer = function () {
        var performer = {role: "", name: ""};

        // Add custom performer fields only once
        if ($scope.data.post.custom_performers.length == 0)
            $scope.data.post.custom_performers.push(performer);
    }

    /* Adding date in calendar */
    $scope.addDate = function (date,element) {
        if (jQuery.inArray(date, element) < 0){
            element.push(date);
        }
    }
    
    /* 
     * Removing date from calendar
     */
    $scope.removeDate = function (index,element) {
        if(element===undefined)
            return;
        element.splice(index, 1);
        $scope.$apply();
    }

    // Adds a date if we don't have it yet, else remove it
    $scope.addOrRemoveDate = function (date,element) {
        var index = jQuery.inArray(date, element);
        if (index >= 0)
            $scope.removeDate(index,element);
        else           
            $scope.addDate(date,element);
        
            
    }
    // Takes a 1-digit number and inserts a zero before it
    $scope.padNumber = function (number) {
        var ret = new String(number);
        if (ret.length == 1)
            ret = "0" + ret;
        return ret;
    }
    
    /*
     * 
     * Save Add/Edit event from main event/dashboard pages.
     */
    $scope.savePost = function (isValid) { 
        $scope.resetSelections();
        // If form is valid against all the angular validations
        if (isValid) {
            if( jQuery('#description').is(':visible') ) {
                $scope.data.post.description= jQuery('#description').val();
            } 
            else 
            {
                if(typeof tinymce!="undefined"){
                    $scope.data.post.description= tinymce.get('description').getContent();
                }
                   
            }
         //   alert($scope.data.post);
            $scope.data.post.id= $scope.post_id;
            $scope.data.post.screen= $scope.screen;
            $scope.progressStart();
            $newVenueAddressInp= $("#em-pac-input");
            if($newVenueAddressInp.length>0){
                $scope.data.post.new_venue_address=$newVenueAddressInp.val();
            }
            EMRequest.send('em_save_event',$scope.data.post).then(function(response){
                $scope.progressStop();
                var responseBody= response.data;
                if(responseBody.success){
                    if(responseBody.data.hasOwnProperty('redirect')){
                        location.href=responseBody.data.redirect;
                    }
                }
                else
                {
                    if(responseBody.data.hasOwnProperty('errors')){
                        $scope.formErrors= responseBody.data.errors;
                        jQuery('html, body').animate({ scrollTop: 0 }, 'slow');
                    }
                }
            });
        }        
    }
    
    /*
     * 
     * Loading Event data on init
     */
    $scope.preparePageData = function () {
        $scope.progressStart();
        $scope.data.em_request_context= 'admin_event';
        // If "Edit" page
        if (em_get('post_id') > 0) {
            $scope.post_id = em_get('post_id');
            $scope.data.post_id= $scope.post_id;
            $scope.post_edit= true;
        } 
        
        // HTTP request to load data
        EMRequest.send('em_load_strings',$scope.data).then(function(response){
            var responseBody= response.data;
            if(responseBody.success){
                $scope.data= responseBody.data;
                $scope.initializeDateTimePickers();
                $scope.setSeatContainerWidth();
                $scope.data.full_load= false;
            }
            $scope.progressStop();
        });
    };
    
    $scope.initializeDateTimePickers= function()
    {
        var minDate= new Date();
        var maxDate;
        $('#event_start_date').datetimepicker({controlType: 'select',oneLine: true,changeYear: true,minDate: new Date()});
        $("#event_end_date").datetimepicker({controlType: 'select',changeYear: true,oneLine: true,timeFormat: 'HH:mm',minDate: new Date()});
        $("#event_start_booking_date").datetimepicker({controlType: 'select',oneLine: true,timeFormat: 'HH:mm',changeYear: true});
        $("#event_last_booking_date").datetimepicker({controlType: 'select',oneLine: true,timeFormat: 'HH:mm',changeYear: true});
    }
     
     $scope.update_start_booking_date=function(){   
        var maxDate=document.getElementById("event_end_date").value;
        $("#event_start_booking_date").datetimepicker('change', {controlType: 'select',oneLine: true,timeFormat: 'HH:mm',changeYear: true,maxDate:maxDate});
     }
     
    /*
     * Compare dates
     */
    $scope.compareDate= function(start_date,end_date,pattern){
        return (jQuery.datepicker.parseDate(pattern,start_date) >  jQuery.datepicker.parseDate(pattern,end_date));
    }
    /*
     * Fetch capacity and seating structure from venue.
     */
    $scope.getCapacity= function()
    {
        var data= {};
        data.venue_id= $scope.data.post.venue; 
        if(data.venue_id==0)
            return;
        data.event_id= $scope.data.post.id;
        $scope.progressStart();
        EMRequest.send('em_get_venue_capcity',data).then(function(response){
                $scope.progressStop();
                $scope.data.post.seating_capacity= parseInt(response.data.capacity);
                $scope.data.post.seats= response.data.seats;
                $scope.setSeatContainerWidth();
        });
    }
    
    /*
     * Select seat column for bulk opeartion (like: Reserver or reset)
     */
    $scope.selectColumn = function (index) {
      $scope.resetSelections();
      for (var i = 0; i < $scope.data.post.seats.length; i++) {

          if($scope.data.post.seats[i][index].type == 'general' || $scope.data.post.seats[i][index].type =='selected'){
              $scope.data.post.seats[i][index].type = 'selected';
              $scope.selectedSeats.push($scope.data.post.seats[i][index]);
          }
      }
      $scope.currentSelection = 'col'
      $scope.currentSelectionIndex = index;
    };

    /*
     * Select individual seat
     */
    $scope.selectSeat = function (seat, row, col) {
        if ($scope.currentSelection == 'row' || $scope.currentSelection == 'col') {
            $scope.resetSelections();
        }
        if (seat.type == 'selected' && seat.type != 'general')
        {
            var index = $scope.selectedSeats.indexOf(seat);
            if (index >= 0) {
                $scope.selectedSeats.splice(index, 1);
            }
            seat.type = 'general';
        } else {
            seat.type = 'selected';
            $scope.selectedSeats.push(seat);
        }
        $scope.currentSelection = 'seat';
        $scope.em_call_popup("#pm-change-password");
    }
    
    /* 
     * Select seats row for bulk operation(like: Reserve or reset)
     */
    $scope.selectRow = function (index) {

        $scope.resetSelections();
         for (var i = 0; i < $scope.data.post.seats[index].length; i++) {
            if($scope.data.post.seats[index][i].type == 'general' || $scope.data.post.seats[index][i].type =='selected')
            {
                 $scope.data.post.seats[index][i].type = 'selected';
                 $scope.selectedSeats.push($scope.data.post.seats[index][i]);
            } 
        }
        $scope.currentSelection = 'row';
        $scope.currentSelectionIndex = index;
    };
    
    // Resetting current selections for seats
    $scope.resetSelections = function () {
        for (var i = 0; i < $scope.selectedSeats.length; i++) {
            $scope.selectedSeats[i].type = 'general';
        }
        $scope.selectedSeats = [];
        $scope.currentSelection = '';
        $scope.currentSelectionIndex = '';
    }
    
    /*
     * Reserving seat. Changing selected seat status to "reserve"
     */
    $scope.reserveSeat = function () {
        var type = 'reserve';
        for (var i = 0; i < $scope.selectedSeats.length; i++) {
            $scope.selectedSeats[i].type = type;
        }
        $scope.selectedSeats = [];
        $scope.currentSelection = '';
    }
    
    /*
     * Calculating margins(aisles) for seat container width
     */
    $scope.adjustContainerWidth= function(columnMargin,index)
    {
        var width= parseInt($scope.seat_container_width.width);
        if(index==0 && columnMargin>0)
        {  
            width += columnMargin;
            $scope.seat_container_width.width = width + "px";
        }
    }
    $scope.$watch('data.post.venue',function(newVal, oldVal){
        if(newVal=='new_venue' && !$scope.mapConfigured){
            $scope.setupMap();
        }
    });
    
    /*
     * Watch for performers dropdown
     */
    $scope.$watch('data.post.performer', function (newVal, oldVal) {
       if(newVal && $scope.postForm.performer)
       {
            if(newVal!==undefined && newVal.length>2 && $scope.data.post.match==1)
               $scope.postForm.performer.$setValidity("invalidPerForMatch", false);
            else
            $scope.postForm.performer.$setValidity("invalidPerForMatch", true);
       }
    });
    
    /*
     * Watch for match field
     */
    $scope.$watch('data.post.match', function (newVal, oldVal) {
        if(newVal && $scope.postForm.performer)
        {
            if(newVal==1 && $scope.data.post.performer.length>2)
            $scope.postForm.performer.$setValidity("invalidPerForMatch", false);
            else
            $scope.postForm.performer.$setValidity("invalidPerForMatch", true); 
        }
    });

    
    /*
     * Watch Dicount No. of tickets
     */
    $scope.$watch('data.post.discount_no_tickets',function(newVal,oldVal)
    {   // Return in case event/post data is not loaded.
        if(!$scope.data.hasOwnProperty('post'))
            return;
        if(!$scope.postForm)
            return;
        
        // No. of tickets should not be excedded seating capacity
        if($scope.postForm.discount_no_tickets){
            if(newVal>0 && $scope.data.post.seating_capacity>0 && newVal>$scope.data.post.seating_capacity)
                $scope.postForm.discount_no_tickets.$setValidity("exceededCapacity", false);
            else
            {
                $scope.postForm.discount_no_tickets.$setValidity("exceededCapacity", true);
            }
        }
    });
    
    /*
     * Watch Maximum ticket per person
     */
    $scope.$watch('data.post.max_tickets_per_person',function(newVal,oldVal)
    { 
        if(!$scope.postForm || !$scope.data.hasOwnProperty('post'))
            return;
        
        if(!$scope.postForm.max_tickets_per_person)
            return;
        
        if(newVal>0 && $scope.data.post.seating_capacity>0 && newVal>$scope.data.post.seating_capacity)
           $scope.postForm.max_tickets_per_person.$setValidity("exceededCapacity", false);
        else
        {
            // Event/post data must be loaded.
            if($scope.data.hasOwnProperty('post'))
                $scope.postForm.max_tickets_per_person.$setValidity("exceededCapacity", true);
        }
    });
    
    /****************** Add/Edit event functions ends here ***************/
    
    
    /*
    * 
    * Add/Edit event popup in calendar view.
    */
    $scope.resetCalendarNewEventPopup= function(){
       $scope.calendarNewEventPopup= {id:0,title: '',start_date:'',end_date:'',all_day:0,performer:[],venue:0,event_type:0};
    } 
    
    /************************** Event List page functions *****************/
    $scope.calendarObject= null;
    $scope.default_view= 'month'; 
    $scope.addNewClicked= false;
    $scope.calRenderedEvents= [];
    $scope.data.hideExpired= 0;
    $scope.calendarNewEventPopup= {};
    $scope.eventView= em_get_url_param('view','month');
    /*
     * 
     * Loading data for list page
     */
    $scope.prepareEventListPage = function () {
        $scope.data.paged= $scope.paged;
        $scope.data.order=$scope.order;
        $scope.data.view=$scope.eventView;
        $scope.calendarObject= $('#em_calendar');
        if($scope.eventView=="cards"){
            $scope.default_view="cards";
        }
        else{
            $scope.default_view= $scope.eventView;
        }
        
        $scope.progressStart();
        EMRequest.send('em_load_admin_events',$scope.data).then(function(response){
            var responseBody= response.data;
            if(responseBody.success){
                $scope.data= responseBody.data;
                $scope.deleteSelections = responseBody.data.total_posts;
            }
            $scope.progressStop();
            
            if($scope.eventView!='cards'){
                $scope.renderCalendar();
                if($scope.eventView!='month')
                    $scope.calendarObject.fullCalendar('changeView',$scope.eventView);
            }
        });
    }
    
    /*
     * 
     * Dynamically changes calendar view between 'Month,Week,Day,List' views.
     */
    $scope.changeEventView= function(){
        if($scope.default_view=='cards'){
            $scope.eventView= 'cards';
            em_redirect('?page=event_magic&view=cards')
            return;
        }
        else if($scope.eventView=='cards'){
            em_redirect('?page=event_magic&view=' + $scope.default_view);
            return;
        }
        $scope.calendarObject.fullCalendar('changeView',$scope.default_view);
    }
    
    /*
     * 
     * Rendering calendar
     */
    $scope.renderCalendar= function(){ 
        var default_view= 'month';
        var dayClickAllowed= true;
        var eventDashLinkClicked= false;
        $scope.calendarObject.fullCalendar({
                header: {
                    left: '',
                    center: 'prev,title,next',
                    right: ''
                },
                editable : true,
                eventDrop: function(event, delta, revertFunc) {
                            if(event.start<new Date()){ // Do not allow to drop event in past dates.
                                revertFunc();
                            }
                            else{
                                // Saving updated event details.
                                $scope.resetCalendarNewEventPopup();
                                $scope.calendarNewEventPopup.start_date= event.start.format('MM/DD/YYYY H:mm');
                                $scope.calendarNewEventPopup.end_date= event.end.format('MM/DD/YYYY H:mm');
                                $scope.calendarNewEventPopup.id=event.id;
                                $scope.calendarNewEventPopup.title=event.title;
                                $scope.calendarNewEventPopup.performer= event.performer;
                                $scope.calendarNewEventPopup.venue= event.venue;
                                $scope.calendarNewEventPopup.event_type= event.event_type;
                                $scope.calendarNewEventPopup.all_day= event.all_day;
                                $(document).trigger('new_event_popup', [$scope.calendarNewEventPopup,event]);
                                $scope.calendarEventDropped();
                            }
                            
                },
                defaultView: default_view,
                events: $scope.data.events,
                eventClick: function (calEvent, jsEvent, view){
                                if(eventDashLinkClicked)
                                    return;
                                // Event selection/deselection
                                if($scope.selections.includes(calEvent.id)){
                                    var index = $scope.selections.indexOf(calEvent.id);
                                    $scope.selections.splice(index, 1);
                                }
                                else
                                {
                                    $scope.selections.push(calEvent.id);
                                }
                                var similarEvents = $scope.calendarObject.fullCalendar('clientEvents', function(e) { return e.id === calEvent.id });
                                for (var i = 0; similarEvents.length > i ; i++){
                                        if($scope.selections.includes(calEvent.id)){
                                            similarEvents[i].className = ['selected'];
                                        } 
                                        else{
                                            similarEvents[i].className = [''];
                                        }
                                        
                                        $scope.calendarObject.fullCalendar('updateEvent', similarEvents[i]);
                                }
                                
                                if(calEvent.id>0){ // Fill existing event data in popup
                                    $scope.resetCalendarNewEventPopup();
                                    $scope.calendarDayClicked = true;
                                    var start_date= moment(calEvent.start,'MM/DD/YYYY h:mm');
                                    var end_date= moment(calEvent.end,'MM/DD/YYYY h:mm');
                                    $("#calendar_start_date").datetimepicker({controlType: 'select',oneLine: true,timeFormat: 'HH:mm',changeYear: true});
                                    $("#calendar_end_date").datetimepicker({controlType: 'select',oneLine: true,timeFormat: 'HH:mm',changeYear: true});
                                    $scope.calendarNewEventPopup.start_date= start_date.format('MM/DD/YYYY h:mm');
                                    $scope.calendarNewEventPopup.end_date= end_date.format('MM/DD/YYYY h:mm');
                                    $scope.calendarNewEventPopup.id=calEvent.id;
                                    $scope.calendarNewEventPopup.all_day=calEvent.all_day;
                                    $scope.calendarNewEventPopup.title=calEvent.title;
                                    $scope.calendarNewEventPopup.performer= calEvent.performer;
                                    $scope.calendarNewEventPopup.venue= calEvent.venue;
                                    $scope.calendarNewEventPopup.performers= $scope.data.performers;
                                    $scope.calendarNewEventPopup.venues= $scope.data.venues;
                                    $scope.calendarNewEventPopup.event_types= $scope.data.event_types;
                                    $scope.calendarNewEventPopup.event_type=  calEvent.event_type;
                                    $(document).trigger('new_event_popup', [$scope.calendarNewEventPopup,calEvent]);
                                    $("#em_edit_event_title").html(calEvent.title);
                                    $scope.formErrors=[];
                                    $scope.$apply();
                                    topY= jsEvent.pageY-20;
                                    leftX=jsEvent.pageX-500;
                                    if(jsEvent.pageX<400){
                                        leftX += 200;
                                    }
                                    $("#calendarPopup").prop('style',"left:" + leftX + "px;top:" + topY + "px;");
                                    $("#calendarPopup").addClass('em_edit_pop');
                                }
                            },
                eventMouseover: function (calEvent, jsEvent, view) {
                                var pop_block= $(jsEvent.currentTarget).find('.em_event_detail_popup');
                                pop_block.show();
                            },
                eventMouseout: function(event, jsEvent, view ){
                                var pop_block= $(jsEvent.currentTarget).find('.em_event_detail_popup'); 
                                pop_block.hide();
                            },
                eventRender: function(event, element) {
                                // Keeping visible event ids for bulk operations. (For example: Delete)
                                if(!$scope.calRenderedEvents.includes(event.id)){
                                    $scope.calRenderedEvents.push(event.id);
                                }
                                element.append(event.popup);
                                var pop_dash_link= element.find('.ep-dashboard-link a'); 
                                pop_dash_link.on('click',function(e){
                                  eventDashLinkClicked= true;
                                });
                                if (event.hasOwnProperty('bg_color')) {
                                    element.css({
                                        'background-color': event.bg_color
                                    });
                                }
                            },
                eventDestroy:function(event, element, view) {
                                // Removing non visible event ids to exclude from bulk operations. (For example: Delete)
                                var index = $scope.calRenderedEvents.indexOf(event.id);
                                if(index>-1){
                                    $scope.calRenderedEvents.splice(index, 1);
                                }
                            },
                dayClick: function(date, jsEvent, view) { // Show popup for creating new events.
                            if(dayClickAllowed){
                                
                                if(date<moment().startOf('day')){
                                return;
                                }
                                $scope.calPopup(date,jsEvent);
                            }
                            
                        }      
        });
    }
    
    $scope.calendarEventDropped= function(){
        $scope.progressStart();
        EMRequest.send('em_save_dropped_event',$scope.calendarNewEventPopup).then(function(response){
            $scope.progressStop();
            var responseBody= response.data;
            if(responseBody.success){
                var ev= responseBody.data.event;
                if($scope.eventView!='cards'){
                    if($scope.calendarNewEventPopup.id>0){ // Update event
                    var similarEvents = $scope.calendarObject.fullCalendar('clientEvents', function(e) { return e.id === ev.id });
                    for (var i = 0; similarEvents.length > i ; i++){
                        similarEvents[i].title= ev.title;
                        similarEvents[i].start= ev.start;
                        similarEvents[i].end= ev.end;
                        similarEvents[i].all_day= ev.allDay;
                        similarEvents[i].id= ev.id;
                        similarEvents[i].performer= ev.performer;
                        similarEvents[i].venue= ev.venue;
                        $(document).trigger('after_dropping_event',[similarEvents[i],ev]);
                        $scope.calendarObject.fullCalendar('updateEvent',similarEvents[i]);
                    }
                    }
                    else 
                    {   // Add new event
                        $scope.calendarObject.fullCalendar( 'renderEvent',ev);
                    }
                }
                else
                {
                    location.href=responseBody.data.redirect;
                }
                
                $scope.calendarDayClicked= false;
            }
        });
    }
    /*
     * 
     * Save/Edit event directly from calendar.
     */
    $scope.savePopupEvent= function(isValid){
        if(!isValid)
            return;
        $scope.formErrors= [];
        $scope.progressStart();
        if($scope.calendarDayClicked){
            $scope.calendarNewEventPopup.title=$("#em_edit_event_title").html();
        }
        EMRequest.send('em_save_popup_event',$scope.calendarNewEventPopup).then(function(response){
            $scope.progressStop();
            $("#em_edit_event_title").html('');
            var responseBody= response.data;
            if(responseBody.success){
                var ev= responseBody.data.event;
                if($scope.eventView!='cards'){
                    if($scope.calendarNewEventPopup.id>0){ // Update event
                    var similarEvents = $scope.calendarObject.fullCalendar('clientEvents', function(e) { return e.id === ev.id });
                    for (var i = 0; similarEvents.length > i ; i++){
                        similarEvents[i].title= ev.title;
                        similarEvents[i].start= ev.start;
                        similarEvents[i].end= ev.end;
                        similarEvents[i].all_day= ev.all_day;
                        similarEvents[i].id= ev.id;
                        similarEvents[i].performer= ev.performer;
                        similarEvents[i].venue= ev.venue;
                        similarEvents[i].event_type= ev.event_type;
                        if($scope.data.colors.hasOwnProperty(ev.event_type)){
                            similarEvents[i].bg_color= $scope.data.colors[ev.event_type];
                            similarEvents[i].backgroundColor="#" + $scope.data.colors[ev.event_type];
                        }
                        $(document).trigger('after_saving_popup_event',[similarEvents[i],ev]);
                        $scope.calendarObject.fullCalendar('updateEvent',similarEvents[i]);
                    }
                    }
                    else 
                    {   // Add new event
                        if($scope.data.colors.hasOwnProperty(ev.event_type)){
                            ev.backgroundColor="#" + $scope.data.colors[ev.event_type];
                        }
                        $scope.calendarObject.fullCalendar( 'renderEvent',ev);
                    }
                }
                else
                {
                    location.href=responseBody.data.redirect;
                }
                
                $scope.addNewClicked= false;
                $scope.calendarDayClicked= false;
            }
            else
            {
                if(responseBody.data.hasOwnProperty('errors')){
                    $scope.formErrors= responseBody.data.errors;
                }
            }
        });
    }
    
    /*
     * Booking fill bar for event list page
     */
    $scope.getProgressStyle= function(post)
    {   
        var style= {"height":"10px","background-color": "#80c9ff", "width": (post.sum/post.capacity) * 100 + "%"}
        return style;
    }
    
    /*
     * Select event
     */
    $scope.selectPost= function(post_id){
        if($scope.selections.indexOf(post_id)>=0){
            em_remove_from_array($scope.selections,post_id);
        }
        else{
            $scope.selections.push(post_id);
        }
        
    }
    
    /*
     * Delete event
     */
     $scope.deletePost = function () {
        $scope.isSelectAll = jQuery('#em_select_all').is(':checked');
        if ($scope.isSelectAll) {
            $scope.deleteAllPost();
        } else {
            var confirmed = confirm("Are you sure you want to delete " + $scope.selections.length + " event(s). Please confirm");
            if (confirmed) {
                //$scope.progressStart(); 

                PostUtility.delete($scope.selections).then(function (data) {
                    location.reload();
                });

            }
        }
    }
    
     $scope.deleteAllPost= function(){
       var confirmed= confirm("Are you sure you want to delete "+ $scope.selections.length +" event(s). Please confirm");
        if(confirmed){
           $scope.progressStart(); 
           PostUtility.delete($scope.selections).then(function(data){
               $scope.deleteSelections=[];
               location.reload();
           });
        }
    }
    
    /*
     * Duplicate event(s)
     */
    $scope.duplicatePosts= function(){
        $scope.progressStart();
        PostUtility.duplicate($scope.selections).then(function(data){
            $scope.progressStop(); 
            location.reload();
        });
    }
    
    /*
     * Pagination navigation
     */
    $scope.pageChanged = function(newPage) {
        $scope.selectedAll=false;
        $scope.paged= newPage;
        $scope.prepareEventListPage();
    };
    
    /*
     * Select all events
     */
    $scope.checkAll = function () {
        if($scope.eventView=='cal'){ // Select all the events
            var allEvents = $scope.calendarObject.fullCalendar('clientEvents', function(e) { return $scope.calRenderedEvents.includes(e.id)});
            for (var i = 0; allEvents.length > i ; i++){
                if($scope.selectedAll){
                    allEvents[i].className = ['selected'];
                    $scope.selections.push(allEvents[i].id);
                }
                else{
                    allEvents[i].className = [];
                    var index= $scope.selections.indexOf(allEvents[i].id);
                    if(index>-1){
                        $scope.selections.splice(index,1);
                    }
                    $scope.selections.push(allEvents[i].id);
                }
                
                $scope.calendarObject.fullCalendar('updateEvent', allEvents[i]);
            }
        }    
        else
        {
            angular.forEach($scope.data.posts, function (post) {
                if ($scope.selectedAll) { 
                    $scope.selections.push(post.id);
                    post.Selected = $scope.selectedAll ? post.id : 0; 
                }
                else{
                    $scope.selections= [];
                    post.Selected = 0;
                }
            });
        }   
    };
   
    /********************** Generate Alphabet seat sequence ****************/
    $scope.getRowAlphabet = function (rowIndex) {
        var indexNumber = "";
        if (rowIndex > 25) {
            indexNumber = parseInt(rowIndex / 26);
            rowIndex = rowIndex % 26;
        }

        return String.fromCharCode(65 + parseInt(rowIndex)) + indexNumber;
    }
    
      $scope.add_event_tourCompleted= function()
    {
        EMRequest.send('em_add_event_tour_completed',$scope.data.post).then(function(response){
           
        });
    }
    $scope.events_tourCompleted= function()
    {
        EMRequest.send('em_event_tour_completed',$scope.data.post).then(function(response){
        
        });
    }
    var event_tour_status = jQuery("#em_tour-status").val();
    $scope.event_tour = function() {
   
        if(event_tour_status == 0){
            jQuery("#em-events-joytips").joyride({
                    tipLocation: 'bottom',
                    autoStart: true,
                    nubPosition: 'top',
                    tipAnimation: 'fade',
                    scrollSpeed: 500,
                    tipAdjustmentY:-30,
                    postRideCallback: $scope.events_tourCompleted
            });
        }
    };
    
    $scope.another_tour = function() {
      event_tour_status=0;
        $scope.event_tour();
        
    }
    
    
    $scope.updateSeatSequence= function(seat)
    {
        if(!seat.seatSequence)
            seat.seatSequence= $scope.getRowAlphabet(seat.row) + "-" + seat.col;    
    }
    
     $scope.em_call_popup= function(dialog) {
        var pmId = dialog + "-dialog";
        $(pmId).siblings('.pm-popup-mask').show();
        $(pmId).show();
        $('.pm-popup-container').css("animation", "pm-popup-in 0.3s ease-out 1");
    }
    
    $scope.em_call_scheme_popup= function(dialog) {
        var selectedSeatSeq= [];    
        for (var i = 0; i < $scope.selectedSeats.length; i++) {
            selectedSeatSeq[i]= $scope.selectedSeats[i].seatSequence;
        }
        $("#custom_seat_sequences").val(selectedSeatSeq.join());
        var pmId = dialog + "-dialog";
        $(pmId).siblings('.pm-popup-mask').show();
        $(pmId).show();
        $('.pm-popup-container').css("animation", "pm-popup-in 0.3s ease-out 1");
        $scope.scheme_popup = $scope.scheme_popup ? false : true;
    }
    
    $('.pm-popup-close, .pm-popup-mask').click(function (){
          $('.pm-popup-mask').hide();
          $('.pm-popup-mask').next().hide();
    });
    
    
    $scope.showSeatOptions= function(seat)
    {
       $scope.currentSeat= seat;
    }
    
    $scope.updateCurrentSeat= function()
    {
       $scope.currentSeat.seatSequence=  $("#custom_seat_seq").val();
    }
    
    $scope.updateCurrentSeatScheme= function()
    {

        var str = $("#custom_seat_sequences").val();
        var strval = str.split(',');

        if (strval.length == $scope.selectedSeats.length && strval.length > 0) {
            for (var i = 0; i < $scope.selectedSeats.length; i++) {
                if (strval[i].trim() != "")
                    $scope.selectedSeats[i].seatSequence = strval[i];
            }
        } else {
            alert('Please verify seating arrangement.');
        }
        $scope.scheme_popup= false;
    }
    
    $scope.addNewPopup= function(){ 
        $scope.formErrors=[];
        date= moment();
        $scope.resetCalendarNewEventPopup();
        $scope.addNewClicked = true;
        date.set({h:12,m:00});
        var startDate= date.format('MM/DD/YYYY h:mm');
        var endDate= date.add('1','day').format('MM/DD/YYYY h:mm');
        $("#new_calendar_start_date").datetimepicker({controlType: 'select',oneLine: true,timeFormat: 'HH:mm',changeYear: true});
        $("#new_calendar_end_date").datetimepicker({controlType: 'select',oneLine: true,timeFormat: 'HH:mm',changeYear: true});
        $scope.calendarNewEventPopup.start_date= startDate;
        $scope.calendarNewEventPopup.end_date= endDate;
        $scope.calendarNewEventPopup.performers= $scope.data.performers;
        $scope.calendarNewEventPopup.venues= $scope.data.venues;
        $scope.calendarNewEventPopup.event_types= $scope.data.event_types;
        setTimeout(function(){
            $scope.$apply();
        },500);
    }
    
    $scope.calPopup= function(date,position){ 
        $scope.formErrors=[];
        $scope.resetCalendarNewEventPopup();
        $("#em_edit_event_title").html('');
        $scope.calendarDayClicked = true;
        var startDate= date.format('MM/DD/YYYY h:mm');
        var endDate= date.add('1','day').format('MM/DD/YYYY h:mm');
        $("#calendar_start_date").datetimepicker({controlType: 'select',oneLine: true,timeFormat: 'HH:mm',changeYear: true});
        $("#calendar_end_date").datetimepicker({controlType: 'select',oneLine: true,timeFormat: 'HH:mm',changeYear: true});
        $scope.calendarNewEventPopup.start_date= startDate;
        $scope.calendarNewEventPopup.end_date= endDate;
        $scope.calendarNewEventPopup.performers= $scope.data.performers;
        $scope.calendarNewEventPopup.venues= $scope.data.venues;
        $scope.calendarNewEventPopup.event_types= $scope.data.event_types;
        setTimeout(function(){
            $scope.$apply();
        },500);
        
        topY= position.pageY-20;
        leftX=position.pageX-500;
        if(position.pageX<400){
            leftX += 200;
        }
        $("#calendarPopup").prop('style',"left:" + leftX + "px;top:" + topY + "px;");
        $("#calendarPopup").removeClass('em_edit_pop');
        
    }
    
    $scope.closeEventPopup= function(){
        $("#new_event_popup").hide();
    }
    
    $scope.syncWithVenue=function(){
        var cnf=confirm("Syncing with the Event Site will cancel all Bookings with the older seating arrangement. Are you sure you want to continue?");
        if(cnf){
            $scope.getCapacity();
        }
    }
    
    $scope.setupMap = function () {
        var gmarkers = []; // To store all the markers
        // Initializing Map
        var map = new google.maps.Map(document.getElementById('map'), {
            zoom: 8,
            center: {lat: 40.731, lng: -73.997}
        });
        var latEl = $("#em_venue_lat");
        var lngEl = $("#em_venue_long");
        var addressEl=$("#em-pac-input");
        input = document.getElementById('em-pac-input'); //Searchbox
        var types = document.getElementById('type-selector');
        map.controls[google.maps.ControlPosition.TOP_LEFT].push(input);
        map.controls[google.maps.ControlPosition.TOP_LEFT].push(types);
        var geocoder = new google.maps.Geocoder;
        var infowindow = new google.maps.InfoWindow;
        var autocomplete = new google.maps.places.SearchBox(input);
        autocomplete.bindTo('bounds', map);
        var marker = new google.maps.Marker({
            map: map,
            anchorPoint: new google.maps.Point(0, -29)
        });
        
        resetMarkers=function(){
            for (i = 0; i < gmarkers.length; i++) {
                gmarkers[i].setMap(null);
            }
        }
        

        // Listener for searchbox changes.
        autocomplete.addListener('places_changed', function () {
            resetMarkers();
            var places = autocomplete.getPlaces();
            if(places.length==0)
                return;
            var place=places[0];
            if (!place.geometry) {
                return;
            }
            // If the place has a geometry, then present it on a map.
            if (place.geometry.viewport) {
                map.fitBounds(place.geometry.viewport);
            } else {
                map.setCenter(place.geometry.location);
                map.setZoom(8);  // Why 17? Because it looks good.
            }
            var marker = new google.maps.Marker({
                position: place.geometry.location,
                map: map
            });
            var address = '';
            if (place.address_components) {
                address = [
                    (place.address_components[0] && place.address_components[0].short_name || ''),
                    (place.address_components[1] && place.address_components[1].short_name || ''),
                    (place.address_components[2] && place.address_components[2].short_name || '')
                ].join(' ');
            }
            infowindow.setContent('<div><strong>' + place.name + '</strong><br>' + address);
            infowindow.open(map,marker);
            gmarkers.push(marker);
        });
    
        map.addListener('click', function (e) {
            resetMarkers();
            latLng = e.latLng;
            var latlng = {lat: parseFloat(latLng.lat()), lng: parseFloat(latLng.lng())};
            geocoder.geocode({'location': latlng}, function (results, status) {
                if (status === google.maps.GeocoderStatus.OK) {
                    if (results[1]) {
                        map.setZoom(13);
                        var marker = new google.maps.Marker({
                            position: latlng,
                            map: map
                        });
                        input.value = results[1].formatted_address;
                        infowindow.setContent(results[1].formatted_address);
                        infowindow.open(map, marker);
                        gmarkers.push(marker);
                    }
                }
            });
        });

    }
});

eventMagicApp.filter('unsafe', function($sce) {
    return function(val) {
        return $sce.trustAsHtml(val);
    };
});